#include <stdio.h>
#include <stdlib.h>

/*
     * 0: Overflow flag
     * 1: Direction flag
     * 2: Interrupt enable flag
     * 3: Trap flag
     * 4: Signed flag
     * 5: Zero flag
     * 6: reserved
     * 7: Auxiliary flag
     * 8: reserved
     * 9: Parity flag
     * 10: reserved
     * 11: Carry flag
     */

#define flags_length 12
#define flag_overflow 0
#define flag_carry 11


/**
 * @param op1 ebp+8
 * @param op2 ebp+12
 * @param what ebp+16
 * @param flags ebp+20
 * @return
 */
extern int addsub(int op1, int op2, char what, unsigned int *flags);

int main(int argc, char **argv) {
    if (argc != 4) {
        printf("Wrong number of arguments\n");
        return -1;
    }

    char what = *argv[2];

    if (what != '+' && what != '-') {
        printf("Only the operators +/- are supported\n");
        return -1;
    }

    int op1 = atoi(argv[1]);
    int op2 = atoi(argv[3]);


    //we need the operators both as signed and unsigned
    signed short sop1 = (short) op1;
    signed short sop2 = (short) op2;
    unsigned short uop1 = (unsigned short) op1;
    unsigned short uop2 = (unsigned short) op2;


    unsigned int *flags = malloc(sizeof(unsigned int));

    int result = addsub(op1, op2, what, flags);

    //we also need the result as signed and unsigned
    short signedRes = (short) result;
    unsigned short unsignedRes = (unsigned short) result;

    printf("Flags:\n");
    printf("O D I T S Z   A   P   C\n");

    int flagArray[flags_length];


    //flags are saved as a decimal value, so we need to convert to binary
    for (int i = 0; i < flags_length; ++i) {
        flagArray[i] = *flags % 2;
        *flags = *flags / 2;
    }

    for (int i = flags_length; i > 0; --i) {
        printf("%d ", flagArray[i - 1]);
    }


    printf("\n\n");

    printf("Ergebnis und Operanden Signed:\n");
    printf("%d %c %d = %d\t", sop1, what, sop2, signedRes);

    printf(flagArray[flag_overflow] == 0 ? "Ergebnis ist richtig!" : "Ergebnis ist falsch!");


    printf("\n\n");


    printf("Ergebnis und Operanden Unsigned:\n");
    printf("%u %c %u = %u\t", uop1, what, uop2, unsignedRes);


    printf(flagArray[flag_carry] == 0 ? "Ergebnis ist richtig!" : "Ergebnis ist falsch!");


    printf("\n\n");

    return 0;
}